--- Mail/SpamAssassin/DnsResolver.pm.orig       2014-05-07 17:54:29 +0200
+++ Mail/SpamAssassin/DnsResolver.pm    2014-06-18 02:13:32 +0200
@@ -205,6 +205,8 @@
      dbg("dns: servers set by config to: %s", join(', ',@ns_addr_port));
    } elsif ($res) {  # default as provided by Net::DNS, e.g. /etc/resolv.conf
-    @ns_addr_port = map(untaint_var("[$_]:" . $res->{port}),
-                        @{$res->{nameservers}});
+    my @ns = $res->UNIVERSAL::can('nameservers') ? $res->nameservers
+                                                 : @{$res->{nameservers}};
+    my $port = $res->UNIVERSAL::can('port') ? $res->port : $res->{port};
+    @ns_addr_port = map(untaint_var("[$_]:" . $port), @ns);
      dbg("dns: servers obtained from Net::DNS : %s", join(', ',@ns_addr_port));
    }

